﻿using System.Windows;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using System.Windows.Controls;
using System.Windows.Shapes;
using System.Windows.Media;
using System.Windows.Media.Imaging;

using Gdip= System.Drawing;
using System.IO;

namespace WpfTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        MainWindow1 wpfDraw;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Map1_Loaded(object sender, RoutedEventArgs e)
        {
            BaseShape.GeometryLibrary = GeometryLibrary.Managed;
            Map1.MapUnit = GeographyUnit.Meter;
            Map1.CurrentExtent = new RectangleShape(-10000000,10000000,10000000,-10000000);

            GoogleMapsOverlay googleOverlay = new GoogleMapsOverlay();
            Map1.Overlays.Add(googleOverlay);
            Map1.Refresh();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Button button = (Button)sender;
            if (button.Name == "DrawCircle")
            {
                Map1.TrackOverlay.TrackMode = TrackMode.Circle;
            }
            else if (button.Name == "EditCircle")
            {
                Map1.TrackOverlay.TrackMode = TrackMode.None;
                foreach (Feature feature in Map1.TrackOverlay.TrackShapeLayer.InternalFeatures)
                {
                    Map1.EditOverlay.EditShapesLayer.InternalFeatures.Add(feature);
                }

                Map1.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear();
                Map1.EditOverlay.CalculateAllControlPoints();
                Map1.Refresh(new Overlay[] { Map1.EditOverlay, Map1.TrackOverlay });
            }
            else if (button.Name == "ShowWpfDraw")
            {
                if (wpfDraw == null)
                {
                    wpfDraw = new MainWindow1();
                    wpfDraw.Show();
                }
            }
        }
    }
}
