﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Gdip = System.Drawing;
using System.IO;

namespace WpfTest
{
    /// <summary>
    /// Interaction logic for MainWindow1.xaml
    /// </summary>
    public partial class MainWindow1 : Window
    {
        float w = 20;
        float h = 20;
        Point previousePoint;
        bool useGdiPlus = true;
        bool isDrag = false;

        public MainWindow1()
        {
            InitializeComponent();
        }


        private void Update()
        {
            if (useGdiPlus)
            {
                Gdip.Bitmap nativeImage = null;
                Gdip.Graphics context = null;

                try
                {
                    nativeImage = new Gdip.Bitmap((int)this.Image1.Width, (int)this.Image1.Height);
                    context = Gdip.Graphics.FromImage(nativeImage);
                    context.Clear(Gdip.Color.Chocolate);
                    context.DrawEllipse(new Gdip.Pen(new System.Drawing.SolidBrush(Gdip.Color.Red), 2f), (float)previousePoint.X - w * .5f, (float)previousePoint.Y - h * .5f, w, h);
                    context.FillEllipse(new Gdip.SolidBrush(Gdip.Color.White), (float)previousePoint.X - w * .5f, (float)previousePoint.Y - h * .5f, w, h);
                    context.Flush();

                    Stream streamSource = new MemoryStream();
                    nativeImage.Save(streamSource, Gdip.Imaging.ImageFormat.Png);

                    BitmapImage imageSource = new BitmapImage();
                    imageSource.BeginInit();
                    imageSource.StreamSource = streamSource;
                    imageSource.EndInit();

                    Image1.Source = imageSource;
                }
                catch
                {
                    if (nativeImage != null) nativeImage.Dispose();
                    if (context != null) context.Dispose();
                }
            }
            else
            {
                DrawingVisual drawingVisual = new DrawingVisual();
                DrawingContext context = drawingVisual.RenderOpen();
                context.DrawEllipse(new SolidColorBrush(Colors.Red), new Pen(new SolidColorBrush(Colors.Black), 2), new Point(previousePoint.X, previousePoint.Y), w * .5, h * .5);
                context.Close();

                RenderTargetBitmap nativeImage = new RenderTargetBitmap((int)ActualWidth, (int)ActualHeight, 96, 96, PixelFormats.Pbgra32);
                nativeImage.Render(drawingVisual);
                Image1.Source = nativeImage;
            }
        }

        private void Image1_MouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            isDrag = true;
        }

        private void Image1_MouseMove(object sender, System.Windows.Input.MouseEventArgs e)
        {
            if (isDrag)
            {
                previousePoint = e.GetPosition(null);
                Update();
            }
        }

        private void Image1_MouseUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            isDrag = false;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            previousePoint = new Point(this.Width/2,this.Height/2);
            Update();
        }
    }
}
